# ec2_key – create or delete an ec2 key pair

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- create or delete an ec2 key pair.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.

force
boolean

Choices:
- no
- yes ←

Force overwrite of already existing key pair if key has changed.

key_material - |  | Public key material.
name - / required |  | Name of the key pair.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token

state
-

Choices:
- present ←
- absent

create or delete keypair

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

wait
boolean

Choices:
- no ←
- yes

Wait for the specified action to complete before returning. This option has no effect since version 2.5.

wait_timeout - | Default: 300 | How long before wait gives up, in seconds. This option has no effect since version 2.5.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # Note: These examples do not set authentication details, see the AWS Guide for details.

    - name: create a new ec2 key pair, returns generated private key
      ec2_key:
        name: my_keypair

    - name: create key pair using provided key_material
      ec2_key:
        name: my_keypair
        key_material: 'ssh-rsa AAAAxyz...== me@example.com'

    - name: create key pair using key_material obtained using 'file' lookup plugin
      ec2_key:
        name: my_keypair
        key_material: "{{ lookup('file', '/path/to/public_key/id_rsa.pub') }}"

    # try creating a key pair with the name of an already existing keypair
    # but don't overwrite it even if the key is different (force=false)
    - name: try creating a key pair with name of an already existing keypair
      ec2_key:
        name: my_existing_keypair
        key_material: 'ssh-rsa AAAAxyz...== me@example.com'
        force: false

    - name: remove key pair by name
      ec2_key:
        name: my_keypair
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
changed boolean | always | whether a keypair was created/deleted Sample: True
key complex | always | details of the keypair (this is set to null when state is absent)
| fingerprint string | when state is present | fingerprint of the key Sample: b0:22:49:61:d9:44:9d:0c:7e:ac:8a:32:93:21:6c:e8:fb:59:62:43
| name string | when state is present | name of the keypair Sample: my_keypair
| private_key string | when a new keypair is created by AWS (key_material is not provided) | private key of a newly created keypair Sample: -----BEGIN RSA PRIVATE KEY----- MIIEowIBAAKC... -----END RSA PRIVATE KEY-----
msg string | always | short message describing the action taken Sample: key pair created

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by the Ansible Community. [community]

### Authors

- Vincent Viallet (@zbal)
- Prasad Katti (@prasadkatti)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.